## part 1: new lib
vlib work
vmap work work

## part 2: load design
vlog -sv -novopt +incdir+../tb +incdir+../../proj/src/define -incr -work work "../../proj/src/advanced_fir_filter/*.vo"
vlog -sv -novopt +incdir+../tb +incdir+../../proj/src/define -incr -work work "../../proj/src/*.v"
vlog -sv -novopt +incdir+../tb +incdir+../../proj/src/define -incr -work work "../tb/*.v"
vlog -novopt -incr -work work "../lib/prim_sim.v"

## part 3: sim design
vsim -L work -novopt work.tb

## part 4: add signals
add wave -group "tb" {sim:/tb/tb_gw5a_inst/clk}
add wave -group "tb" {sim:/tb/tb_gw5a_inst/rstn}
add wave -group "tb" {sim:/tb/tb_gw5a_inst/fir_valid_i}
add wave -group "tb" {sim:/tb/tb_gw5a_inst/fir_sync_i}
add wave -group "tb" {sim:/tb/tb_gw5a_inst/fir_data_i}
add wave -group "tb" {sim:/tb/tb_gw5a_inst/fir_rfi_o}
add wave -group "tb" {sim:/tb/tb_gw5a_inst/fir_valid_o}
add wave -group "tb" {sim:/tb/tb_gw5a_inst/fir_sync_o}
add wave -group "tb" {sim:/tb/tb_gw5a_inst/fir_data_o}
add wave -group "tb" {sim:/tb/tb_gw5a_inst/capture_index}
add wave -group "tb" {sim:/tb/tb_gw5a_inst/capture_data}

## part 5: show ui 
view wave
view structure
view signals

## part 6: run 
run -all
